import React from "react";
import axios from 'axios';
import Amplify, { Auth } from 'aws-amplify';


// export const initInterceptors = () => {
// 	let isRefreshing = false;
// 	let jwtToken = '';
// 	axios.interceptors.request.use(
// 		async (config) => {
// 			document.getElementById('loader').classList.add('loaderShow');
// 			document.getElementById('loader').classList.remove('loaderHide');
// 			const localStorage = await getAuthConfig();
// 			if (localStorage && localStorage.authConfigs) {
// 				config.headers.Authorization = !isRefreshing ? localStorage.authConfigs.accessToken : jwtToken;
// 			}
// 			//if the Authorization does not pass to header
// 			if (config.headers && config.headers['X-No-Authorization'] && config.headers['X-No-Authorization'] == true) {
// 				delete config.headers.Authorization;
// 				delete config.headers['X-No-Authorization'];
// 			}
// 			return Promise.resolve(config);
// 		},
// 		(error) => {
// 			return Promise.reject(error);
// 		},
// 	);

// 	axios.interceptors.response.use(
// 		(response) => {
// 			document.getElementById('loader').classList.remove('loaderShow');
// 			document.getElementById('loader').classList.add('loaderHide');
// 			// Any status code that lie within the range of 2xx cause this function to trigger
// 			isRefreshing = false;
// 			return response;
// 		},
// 		async (error) => {
// 			const { config, response } = error;
// 			const originalRequest = config;
// 			if (response && response.status === 401) {
// 				let data = {};
// 				if (!isRefreshing) {
// 					isRefreshing = true;
// 					data = await refreshAccessToken();
// 					if (data) {
// 						AuthSubscriber.sendToPublisher('onMessageFromSubscriber', data);
// 						const retryOrigReq = new Promise((resolve) => {
// 							jwtToken = data.signInUserSession.accessToken.jwtToken;
// 							// originalRequest.headers.Authorization = data.accessToken;
// 							resolve(axios(originalRequest));
// 						});
// 						return retryOrigReq;
// 					}
// 				}
// 			}
// 			document.getElementById('loader').classList.remove('loaderShow');
// 			document.getElementById('loader').classList.add('loaderHide');
// 			return Promise.reject(error);
// 		},
// 	);
// };

export const refreshAccessToken = async () => {
	const configs = await getAuthConfig();
	return trySignIn(configs.awsConfigs);
};

export const getAuthConfig = async () => {
	return localforage.getItem('configs');
};

export const trySignIn = async (awsConfigs) => {
	Amplify.configure({
		Auth: awsConfigs,
	});
	return Auth.currentAuthenticatedUser({
		bypassCache: true,
	});
};

export class AuthSubscriber {
	static retrivedAuthConfig = false;

	static buildSubscriber = (newSubscriptionEvent, subscriber, storeData) => {
		document.addEventListener(subscriber.listenEvent, (e) => {
			if (!e || !e.detail) {
				return;
			}
			storeData(e.detail);
			this.retrivedAuthConfig = true;
		});

		const event = new CustomEvent(newSubscriptionEvent,
			{
				detail: {
					...subscriber,
				},
			});
		document.dispatchEvent(event);
	}

	static sendToPublisher = async (notifyPublisherEvent, data) => {
		const event = new CustomEvent(notifyPublisherEvent, { detail: data });
		document.dispatchEvent(event);
	};
}

export class Subscriber {
	constructor(appName, listenEvent) {
		this.appName = appName;
		this.listenEvent = listenEvent;
	}
}

export class initInterceptors extends React.Component {
	constructor(props) {
		super(props);
		this.initInterceptors();
	}

	initInterceptors = () => {
		let isRefreshing = false;
		let jwtToken = '';
		axios.interceptors.request.use(
			async (config) => {
				document.getElementById('loader').classList.add('loaderShow');
				document.getElementById('loader').classList.remove('loaderHide');
				const localStorage = await getAuthConfig();
				if (localStorage && localStorage.authConfigs) {
					config.headers.Authorization = !isRefreshing ? localStorage.authConfigs.accessToken : jwtToken;
				}
				//if the Authorization does not pass to header
				if (config.headers && config.headers['X-No-Authorization'] && config.headers['X-No-Authorization'] == true) {
					delete config.headers.Authorization;
					delete config.headers['X-No-Authorization'];
				}
				return Promise.resolve(config);
			},
			(error) => {
				return Promise.reject(error);
			},
		);

		axios.interceptors.response.use(
			(response) => {
				document.getElementById('loader').classList.remove('loaderShow');
				document.getElementById('loader').classList.add('loaderHide');
				// Any status code that lie within the range of 2xx cause this function to trigger
				isRefreshing = false;
				return response;
			},
			async (error) => {
				const { config, response } = error;
				const originalRequest = config;
				if (response && response.status === 401) {
					let data = {};
					if (!isRefreshing) {
						isRefreshing = true;
						data = await refreshAccessToken();
						if (data) {
							AuthSubscriber.sendToPublisher('onMessageFromSubscriber', data);
							const retryOrigReq = new Promise((resolve) => {
								jwtToken = data.signInUserSession.accessToken.jwtToken;
								// originalRequest.headers.Authorization = data.accessToken;
								resolve(axios(originalRequest));
							});
							return retryOrigReq;
						}
					}
				}
				document.getElementById('loader').classList.remove('loaderShow');
				document.getElementById('loader').classList.add('loaderHide');
				return Promise.reject(error);
			},
		);
	};
}